;Hanoi v1.1 by Alban Gervaise
;last released 28/11/98


        include "doorsos.h"
        include "userlib.h"
        include "graphlib.h"
        include "hanoi.pic"

        xdef _main
        xdef _comment
        xdef _ti89

Take_str MACRO
        move.w \1,d5
        move.w \2,d6
        move.w \3-1,d7
        move.w d7,d4
        bsr take_string
        ENDM

print_d0 MACRO
        bsr print_value
        move.w  \3,-(a7)
        move.l  a0,-(a7)
        move.w  \2,-(a7)
        move.w  \1,-(a7)
        jsr     doorsos::DrawStrXY
        lea 10(a7),a7
        ENDM


max_nbr equ 9

_main:
        bsr ini_screen
        tst.w exit_var
        beq main_loop
        move.w #3,nbr
main_bis
        bsr ini_home_screen
        bra choose_loop

ini_home_screen:
        jsr graphlib::clr_scr
        move.w #10,d0
        move.w #10,d1
        move.b #%11111111,d3
        move.l #picture,a0
        jsr graphlib::put_sprite_mask

        move.w #1,-(a7)
        jsr doorsos::FontSetSys
        move.w #1,-(a7)
        pea choose(pc)
        move.w #40,-(a7)
        move.w #10,-(a7)
        jsr doorsos::DrawStrXY
        pea email(pc)
        jsr doorsos::ST_showHelp
        clr.w -(a7)           ;
        jsr doorsos::ST_busy      ;   
        move.w #1,-(a7)
        jsr doorsos::FontSetSys
        clr.w -(a7)
        jsr doorsos::ST_busy      ;*2
        clr.l d0
        move.w nbr,d0
        mulu #16,d0
        move.l #high3-16*3,a1
        add.l d0,a1
        move.w #4,-(a7)
        move.l a1,-(a7)
        move.w #70,-(a7)
        move.w #10,-(a7)
        jsr doorsos::DrawStrXY    ;*10
        move.w 12(a1),d0
        bsr print_value
        move.w #4,-(a7)
        move.l a0,-(a7)
        move.w #70,-(a7)
        move.w #112,d0
        mulu #6,d1
        sub.W d1,d0
        move.w d0,-(a7)
        jsr doorsos::DrawStrXY
        move.w 14(a1),d0
        bsr print_value
        move.w #4,-(a7)
        move.l a0,-(a7)
        move.w #70,-(a7)
        move.w #150,d0
        mulu #6,d1
        sub.W d1,d0
        move.w d0,-(a7)
        jsr doorsos::DrawStrXY
        move.w #4,-(a7)
        pea struc(pc)
        move.w #50,-(a7)
        move.w #60,-(a7)
        jsr doorsos::DrawStrXY
        lea 62(a7),a7
        move.w nbr,d0
        print_d0 #72,#50,#1
        rts

choose_loop:
        bsr ini_home_screen
        jsr userlib::idle_loop
        cmp.w #264,d0
        beq exit
        cmp.w #13,d0
        beq start_game
        cmp.w #338,d0
        beq moins
        cmp.w #344,d0
        beq plus 
        bra choose_loop
moins   cmp.w #3,nbr
        beq choose_loop
        sub.w #1,nbr
        bra choose_loop
plus    cmp.W #max_nbr,nbr
        beq choose_loop
        add.w #1,nbr
        bra choose_loop

start_game:
        bsr disp
        clr.w c_seconde
        clr.w time
        move.l #pile1,a0       ; pile 1,2,3 mais pas 0 ;-)  sont vierges au debut
        move.w #(max_nbr+1)*3,d0          ;
ini_pile_loop:                 ;
        clr.w (a0)+        ;
        dbra d0,ini_pile_loop  ;
        move.l #pile1,a0       ;
        move.w nbr,max_nbr*2(a0)     ; on met le nombre d'anneaux dans pile1+18
        move.w nbr,d0
        mulu #2,d0
        add.l d0,a0
        move.w nbr,d0         ; on rempli la pile avec les rondelles de valeurs
        sub.w #1,d0            ; decroissant (pour 3= 7,8,9,0,0,0,0...
        move.w #max_nbr,d1           ;              pour 4= 6,7,8,9,0,0,0...)
ini_loop_pile1:
        move.w d1,-(a0)
        sub.w #1,d1
        dbra d0,ini_loop_pile1 ; c'est fait
        clr.w pos          ; on positionne le curseur sur la preimiere pile
        move.w nbr,d0
        sub.w #2,d0        ;
        move.w #2,d1       ; gives the minimum moves of the level
min_l   lsl.w #1,d1        ;
        dbra d0,min_l
        sub.w #1,d1
        move.w d1,min
        clr.w move
        bsr ini_screen         ; on affiche les piles avec leurs anneaux
        bra main_loop          ; on va a main_loop

ini_screen:              ; affiche l'ecran 
        jsr graphlib::clr_scr
        clr.w -(a7)
        jsr doorsos::FontSetSys
        bsr disp
        move.w #4,-(a7)
        pea level(pc)
        clr.w -(a7)
        clr.w -(a7)
        jsr doorsos::DrawStrXY
        move.w nbr,d0
        print_d0 #25,#0,#1
        move.w #4,-(a7)
        pea min_str(pc)
        clr.w -(a7)
        move.w #38,-(a7)
        jsr doorsos::DrawStrXY
        move.w min,d0
        print_d0 #75,#0,#1
        move.w #4,-(a7)
        pea yours(pc)
        clr.w -(a7)
        move.w #95,-(a7)
        jsr doorsos::DrawStrXY
        lea 32(a7),a7
        move.w move,d0
        print_d0 #140,#0,#1
        moveq #7,d0  ; d0=X0
        moveq #70,d1 ; d1=Y0
        moveq #44,d2
        moveq #3,d3
        moveq #2,d4
        move.w d4,d7
loop    jsr graphlib::fill
        movem d0-d7,-(a7)
        addi #21,d0
        moveq #13,d1
        moveq #2,d2
        moveq #57,d3
        jsr graphlib::fill
        movem (a7)+,d0-d7
        add.w #51,d0
        dbra d7,loop
draw_line:               ; dessine les anneaux
        move.l #pile1,a0
        move.w #2,d7
        clr.w d5
loop_line:
        move.w #66,d1    ; d1=x1
        move.w #max_nbr-1,d6     ; d6=loop counter
loop_line_bis:
        move.w (a0)+,d0
        tst.w d0
        beq passe
        move.w d0,d2
        mulu #2,d0
        move.w #51,d4
        mulu d5,d4
        addq #7,d0
        add.w d4,d0
        mulu #4,d2
        move.w #44,d4
        sub.w d2,d4
        move.w d4,d2
        moveq #2,d3
        moveq #2,d4
        jsr graphlib::fill
passe   sub.w #5,d1
        dbra d6,loop_line_bis
        move.w (a0)+,d0
        add.w #1,d5
        dbra d7,loop_line        

print_curseur:          ; affiche le curseur
        move.w pos,d0
        mulu #51,d0
        add.w #26,d0
        move.w #1,-(a7)
        move.w #75,-(a7)
        move.w d0,-(a7)
        move.w #27,-(a7)
        jsr userlib::DrawCharXY
        lea 8(a7),a7
        rts

main_loop:
        bsr print_curseur
        bsr get_key
        cmp.w #264,d0
        beq main_bis
        cmp.w #338,d0
        beq move_left
        cmp.w #344,d0
        beq move_right
        cmp.w #4440,d0
        beq go_right
        cmp.w #4434,d0
        beq go_left
        cmp.w #277,d0
        beq quick_exit
        cmp.w #263,d0
        beq start_game
        bra main_loop
        
quick_exit:
        clr.w exit_var
        rts

move_left:
        bsr old_curseur
        tst.w pos
        beq mcl
        sub.w #1,pos
        bra main_loop
mcl     move.w #2,pos
        bra main_loop

move_right:
        bsr old_curseur
        cmp.w #2,pos
        beq mcr
        add.w #1,pos
        bra main_loop
mcr     clr.w pos
        bra main_loop

old_curseur:
        move.w pos,d0
        mulu #51,d0
        add.w #26,d0
        move.w #4,-(a7)
        pea blank(pc)
        move.w #75,-(a7)
        move.w d0,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        rts

go_left:
        move.w pos,d0
        tst.w d0
        beq pmtl
        sub.w #1,d0
        bra check
pmtl    move.w #2,d0
        bra check

go_right:
        move.w pos,d0
        cmp.w #2,d0
        beq pmtr
        add.w #1,d0
        bra check
pmtr    clr.w d0

check   move.w d0,d2      ; d0 et d2 = pile ou mettre la piece
        bsr give_var      ; a0= adresse de la pile et d0=nombre de piece deja mise
        clr.w d1
        tst.w d0
        beq bon
        mulu #2,d0
        sub.w #2,d0
        add.l d0,a0       ; a0=nombre de la derniere piece entree
        move.w (a0),d1
bon     move.w pos,d0
        bsr give_var
        tst.w d0          ; si aucune piece dans celui choisi on part!
        beq main_loop     ;
        sub.w #1,d0
        mulu #2,d0
        add.l d0,a0
        move.w (a0),d0    ; d0=deniere piece mise sur l'anneau choisi
        cmp.w d1,d0
        blt main_loop     ; si d1<d0, on part
        clr.w (a0)        ; on prend la piece et on efface sa valeur
        move.w d0,d1      ; d0=valeur de la derniere piece mise et a bouge
        move.w pos,d0
        bsr give_var
        sub.w #1,max_nbr*2(a0)   ; -1 piece dans la pile
        move.w d2,d0
        bsr give_var
        move.w max_nbr*2(a0),d0
        add.w #1,max_nbr*2(a0)   ; +1 piece dans la pile
        mulu #2,d0
        add.l d0,a0
        move.w d1,(a0)
        add.w #1,move
        bsr ini_screen
        move.l #pile3,a0
        move.w max_nbr*2(a0),d0
        cmp.w nbr,d0   ; si le nombre d'anneaux dans pile vaut nbr alors gagner
        beq gagne
        bra main_loop
give_var:
        move.l #pile1,a0
        mulu #(max_nbr+1)*2,d0
        add.l d0,a0
        move.w max_nbr*2(a0),d0
        rts

gagne   move.w #2,-(a7)
        jsr doorsos::FontSetSys
        move.w #4,-(a7)
        pea win_str(pc)
        move.w #80,-(a7)
        move.w #20,-(a7)
        jsr doorsos::DrawStrXY
        move.w #1,-(a7)
        jsr doorsos::FontSetSys
        lea 14(a7),a7
\wait   move.w (doorsos::MaxHandles+$1E),d0
        cmp.w #264,d0
        beq \apres
        cmp.w #13,d0
        bne \wait
\apres  clr.l d0
        move.w nbr,d0
        mulu #16,d0
        move.l #high3-16*3,a5
        add.l d0,a5
        move.w 12(a5),d0
        cmp.w move,d0
        blt main_bis
        move.w 14(a5),d0
        cmp.w time,d0
        ble main_bis
        clr.l d0
        move.w nbr,d0
        mulu #16,d0
        move.l #high3-16*3,a5
        add.l d0,a5
        clr.b (a5)
        move.w move,12(a5)
        move.w time,14(a5)
        jsr userlib::idle_loop
        bsr ini_home_screen
        move.w #10,d0
        move.w #40,d1
        move.w #140,d2
        move.w #20,d3
        move.w #1,d4
        jsr graphlib::fill
        move.w #4,-(a7)
        pea enter_str(pc)
        move.w #40,-(a7)
        move.w #30,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        Take_str #10,#70,#11
        bra _main

take_string:
        jsr userlib::idle_loop
        cmp.w #257,d0
        beq undo
        cmp.w #264,d0
        beq \bon
        cmp.w #13,d0
        beq \bon
        move.b d0,(a5)+
        move.w #2,-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        move.w d0,-(a7)
        jsr userlib::DrawCharXY
        lea 8(a7),a7
        add.w #6,d5
        dbra d7,take_string
\bon    cmp.w d4,d7
        beq take_string
        clr.b (a5)
        rts
undo    cmp.w d4,d7
        beq take_string
        add.w #1,d7
        clr.b -(a5)
        sub.w #6,d5
        move.w #4,-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        move.w #32,-(a7)
        jsr userlib::DrawCharXY
        lea 8(a7),a7
        bra take_string

exit    move.w d0,exit_var
        rts

get_key bsr delay
        tst.w (doorsos::kb_vars+$1C)
        beq get_key
        move.w (doorsos::MaxHandles+$1E),d0
        clr.w (doorsos::kb_vars+$1C)
        rts

print_value:
        move.l #str+8,a0
        clr.b (a0)
        clr.l d1
print_loop:
        add.l #1,d1
        divu #10,d0
        swap d0
        add.b #48,d0
        move.b d0,-(a0)
        clr.w d0
        swap d0
        tst.w d0
        bne print_loop
        rts

delay   add.w #1,c_seconde
        cmp.w #65000,c_seconde
        bne exit
        add.w #1,time
        clr.w c_seconde
disp    pea time_str(pc)
        jsr doorsos::ST_showHelp  ;*4
        move.w time,d0
        print_d0 #20,#95,#4
        clr.w -(a7)
        jsr doorsos::ST_busy      ;*2
        move.w #4,-(a7)
        move.l #best_str,-(a7)
        move.w #95,-(a7)
        move.w #40,-(a7)
        jsr doorsos::DrawStrXY    ;*10
        clr.l d0
        move.w nbr,d0
        mulu #16,d0
        move.l #high3-16*3,a1
        add.l d0,a1
        move.w #4,-(a7)
        move.l a1,-(a7)
        move.w #95,-(a7)
        move.w #60,-(a7)
        jsr doorsos::DrawStrXY    ;*10
        move.w 12(a1),d0
        print_d0 #110,#95,#4
        move.w 14(a1),d0
        print_d0 #140,#95,#4
        lea 26(a7),a7
        rts


pile1     ds.w max_nbr+1
pile2     ds.w max_nbr+1
pile3     ds.w max_nbr+1

pos       dc.w 0
time      dc.w 0
exit_var  dc.w 1

nbr       dc.w 0
min       dc.w 0
move      dc.w 0
c_seconde dc.w 0

win_str   dc.b "Congratulations!",0
time_str  dc.b "time:",0
best_str  dc.b "best:",0
yours     dc.b "your moves:",0
enter_str dc.b "Enter your name!",0
level     dc.b "Level:",0
min_str   dc.b "min moves:",0            
email     dc.b "v1.1 by Endive <GefunS@I-France.com>",0
choose    dc.b "choose your level (3-9)",0
str       dc.b "        ",0
blank     dc.b "     ",0  ; blanc pour effacer cette pile
struc     dc.b 17,"   ",18,0

high3 dc.b "best score3",0,39,15,39,15  ; 36*256+15=9999
high4 dc.b "best score4",0,39,15,39,15
high5 dc.b "best score5",0,39,15,39,15
high6 dc.b "best score6",0,39,15,39,15
high7 dc.b "best score7",0,39,15,39,15
high8 dc.b "best score8",0,39,15,39,15
high9 dc.b "best score9",0,39,15,39,15

_comment dc.b "Hanoi's Tower by Endive",0

 end
                       
;by Alban Gervaise
